#!/usr/bin/env perl
# $Id: kuttukibbs.cgi,v 1.12 2004/12/15 14:09:58 yto Exp $

# modified by Kissui Shimotsuki at 2008/01/25

use strict;

### ԽƲ
my $conf_file = "kuttukibbs.conf"; # 桼եξ

### 桼 (kuttukibbs.conf Ǥޤ)
my $log_dir = "kblog";		# ȥե֤ǥ쥯ȥ
my $latest_comment_display_num = 20; # ǿɽΤȤ˰٤ɽ
my $kb_js_display_max = 5;	# ɽ륳Ȥο for js
my $kb_js_strlen_max = 40;	# 1 Ȥɽʸ for js
my $admin_log_file = "kblog/log.txt"; # ѥե
my $passwd = "";		# ѥѥ
my $noname = "???";		# ǥեȤƼ̾
my $page_template_default;
my $page_template_latest;
my $page_template_edit;
my $charset = "EUC-JP";		# ʸ

my $timelimit = 10; # time limit
my $linklimit = 2; # limit of links
# my $spam_log_file = "spamlog.txt";

### Хѿ
my $latest_id = -1;		# ǿΥȤ ID
my %com_hash;			# ȤǼϥå
my $URLCHARS = "[-_.!~*'a-zA-Z0-9;/?:@&=+,%\#\$]";


# 桼եɤ߹
if (not -e $conf_file) {
    print "error: can't read $conf_file\n";
    exit;
}
open(CONF, "$conf_file") or die "can't open $conf_file : $!";
my $conf = join('', <CONF>);
eval $conf;

# ߻γ
use POSIX qw(strftime);
my $what_time_is_it_now = strftime "%Y-%m-%d %H:%M:%S", localtime;
my $time = time;

use CGI;
my $q = new CGI;
#print $q->Dump;

my $mode = $q->param('mode');

# 桼
my $name = $q->param('name');
my $mail_or_url = $q->param('mail');
my $body = $q->param('body');
my $spamurl = $q->param('url');
my $spamemail = $q->param('email');
my $spame_mail = $q->param('e-mail');
my $spamcomment = $q->param('comment');
my $spamtext = $q->param('text');
my $disptime = $q->param('4d');

# header
if ($mode eq 'write') {
    escape_string(\$name);	
    escape_string(\$mail_or_url);	
    my $cookie = $q->cookie(-name=>'kuttukibbs', 
			    -value=>"$name\t$mail_or_url", 
			    -expires=>'+30d');
    print $q->header(-cookie=>$cookie, -charset=>$charset);
} else {
    print $q->header(-charset=>$charset);
    if (defined $q->cookie('kuttukibbs')) {
	($name, $mail_or_url) = split(/\t/, $q->cookie('kuttukibbs')); 
    }
    escape_string(\$name);	
    escape_string(\$mail_or_url);	
}

my $cgi_url = $q->url();

my $comments;
my $page_html;


if ($mode eq 'latest') {output_latest();}

# оݤξ
my $logid = $q->param('id'); # Ȥ IDե
$logid =~ s{[^a-zA-Z0-9\.\-\#_]}{_}g;
exit if ($logid =~ /^\s*$/);
my $target_url = id2url($logid); # оݤ URL
$cgi_url .= "?id=$logid";
my $fn_pref = "$log_dir/$logid";

### ɤ߹
my $fn = "$fn_pref.log";
my $all;
read_file($fn, \$all);

if ($mode eq "edit") {
    my $co = $q->param('content');
    if (defined $co) {
	my $request_method = $q->request_method();
	if ($request_method ne 'POST') {
		exit(1);
	}
	my $pw = $q->param('passwd');
	if (defined $pw and $pw ne "" and $pw eq $passwd) { 
	    rename $fn, $fn."~";
	    save_file($fn, \$co);
	    read_file($fn, \$all);
	    set_comment_hash(\%com_hash, \$all);
            write_to_jsfile($fn_pref.".js"); # JavaScript Feed ե
            %com_hash = ();
	} else {
	    print "wrong password!\n";
	}
    } else {
	my $content = $all;
	$content =~ s/&/&amp;/g;
	eval qq(\$page_html = << "FFF"\n$page_template_edit\nFFF\n);
	print $page_html;
	exit;
    }
}

set_comment_hash(\%com_hash, \$all);

### 񤭹
if ($mode eq "write") {
	my $request_method = $q->request_method();
	if ($request_method ne 'POST') {
		write_to_spamlogfile();
	}
    $name = $noname if ($name =~ /^\s*$/sm);
    

	if ($spamurl ne '' || $spamemail ne '' || $spame_mail ne '' || $spamcomment ne '' || $spamtext ne '') {
		write_to_spamlogfile();
	}
	if ($time < $disptime || $time > $disptime + ($timelimit * 60)) {
		write_to_spamlogfile();
	}
	if ($body =~ /<a .*?href=.+?>.+?<\/a>/i) {
		write_to_spamlogfile();
	}
	if ($body =~ /<[^<>]*?http:\/\/[^<>]*?>/i) {
		write_to_spamlogfile();
	}
	if (my @linklist = $body =~ /http:\/\/$URLCHARS+/g) {
		if (scalar(@linklist) > $linklimit) {
			write_to_spamlogfile();
		}
	}

    if ($body !~ /\A\s*\Z/m) {
	escape_string(\$name);	
	escape_string(\$mail_or_url);	
	escape_string(\$body);

	$body =~ s/\r?\n/<br>/gsm;
	
	my $name_tmp = $name;
	if ($mail_or_url =~ /^http:\/\/$URLCHARS+$/) {
	    $name_tmp = qq(<a href="$mail_or_url">$name</a>);
	}
	
	$latest_id++;
	$com_hash{$latest_id}{n} = $name_tmp;
	$com_hash{$latest_id}{m} = $body;
	$com_hash{$latest_id}{d} = $what_time_is_it_now;
	
	write_to_logfile();	# եؤν񤭹
	write_to_jsfile($fn_pref.".js"); # JavaScript Feed եؤν񤭹
	write_to_adminlogfile(); # ѥեؤν񤭹
    }
}

### ɽ
for (my $i = $latest_id; $i >= 0; $i--) {
    next unless defined $com_hash{$i};
    $comments .= make_comment_html($com_hash{$i}, $i + 1);
}

eval qq(\$page_html = << "FFF"\n$page_template_default\nFFF\n);
print $page_html;
exit;

#----------------------------------------------------------------------

###
sub escape_string {
    my ($sp) = @_;
    $$sp =~ s/</&lt;/g;
    $$sp =~ s/>/&gt;/g;
    $$sp =~ s/\"/&quot;/g;	# "
}


### եɤ
sub read_file {
    my ($fn, $strp) = @_;
#    if (-e $fn and -s $fn != 0) {
    if (-e $fn) {
	open(F, $fn) or die "can't open $fn : $!\n";
	$$strp = join('', <F>);
	close(F);
    }
}

### ե򥻡
sub save_file {
    my ($fn, $strp) = @_;
    open(F, "> $fn") or die "can't open $fn : $!\n";
    flock(F, 2);
    print F $$strp;
    close F;
}

### ȥեϤƥȤȤ hash ˳Ǽ롣
sub set_comment_hash {
    my ($hashp, $allp) = @_;
    foreach (split(/\r?\n/, $$allp)) {
	if (/^([nmd])\[(\d+)\] = "(.*?)";$/) {
	    $hashp->{$2}{$1} = $3;
	    $latest_id = $2 if ($latest_id < $2);
	}
    }
}


### Ƚ HTML 롣
sub make_comment_html {
    my ($commentp, $commentid) = @_;
    my $mes = $commentp->{'m'};
    $mes =~ s{((s?https?|ftp)://($URLCHARS+))}{<a href="$1">$1</a>}g;

    my $anchor = qq(<span class="canchor">*</span>);
    my $page_info = "";
    if (defined $commentp->{i}) {
	my $id = $commentp->{i};
	my $url = id2url($id);
	my $bbs_url = "$cgi_url?id=$id";
	$page_info = qq(<span class="page">[<a href="$url">$url</a>, 
			<a href="$bbs_url">BBS</a>]</span>);
    } else {
	$anchor = qq(<a name="$commentid" href="$cgi_url\#$commentid">
		     <span class="canchor">*</span></a>);
    }
    my $rv .= << "DAY"
<div class="acomment">
<div class="commentator">
$anchor
<span class="commentator">$$commentp{'n'}</span>
<span class="commenttime">$$commentp{'d'}</span>
$page_info
</div>
<p>$mes</p>
</div>
DAY
    ;
    return $rv;
}


### եؤν񤭹
sub write_to_logfile {
    my $fn = "$fn_pref.log";
    my $str;
    foreach (sort {$a <=> $b} keys %com_hash) {
	$str .= qq(n[$_] = "$com_hash{$_}{n}";\nm[$_] = "$com_hash{$_}{m}";
d[$_] = "$com_hash{$_}{d}";\n);
    }
    save_file($fn, \$str);
}


### JavaScript Feed եؤν񤭹
sub write_to_jsfile {
    my ($jsfn) = @_;
#    my $jsfn = "$fn_pref.js";
    my $str = "";
    my $cnt = $kb_js_display_max;
    for (my $i = $latest_id; $i >= 0; $i--) {
	next unless defined $com_hash{$i};

	my ($n,$m,$d)  = ($com_hash{$i}{n},$com_hash{$i}{m},$com_hash{$i}{d});
	$n =~ s/^(.{1000}).*$/$1/;
	$m =~ s/<br>//ig;	# ԥϺ

	$n =~ s/\\/\\\\/g;
	$m =~ s/\\/\\\\/g;

	$n =~ s/\'/\\'/g;
	$m =~ s/\'/\\'/g;

	# ʸ¿Ȥå - charsetˤꤢ뤫
	if ($m =~ s/^(([\x80-\xff].|[\x00-\x7f]){$kb_js_strlen_max}).*$/$1/) {
	    $m =~ s/((s?https?|ftp):\/\/$URLCHARS+)$/$2/;
	    $m .= "...";
	}
	# URL to anchor
	$m =~ s/((s?https?|ftp):\/\/$URLCHARS+)/<a href="$1">$1<\/a>/ig;

	$str .= << "JS";
document.writeln('<p><span class="canchor">_</span>');
document.writeln('<span class="commentator">$n</span>');
document.writeln(' [$m]</p>');
JS
    ;

	$cnt--;
	last if ($cnt <= 0);
    }
    if ((keys %com_hash) > $kb_js_display_max) {
	$str .= << "JS";
document.writeln('<p><span class="canchor">_</span>');
document.writeln('<span class="commentator">...</span></p>');
JS
    ;
    }

    save_file($jsfn, \$str);
}


### ѥեؤν񤭹
sub write_to_adminlogfile {
    my $str = "remote_host: ". $q->remote_host(). "\n";
    $str .= "id: $logid\n";
    $str .= "mail or url: $mail_or_url\n";
    $str .= << "ADD";		# ɲ
n[$latest_id] = "$name";
m[$latest_id] = "$body";
d[$latest_id] = "$what_time_is_it_now";

ADD
    ;
    open(F, ">> $admin_log_file") or die "can't open $admin_log_file : $!\n";
    flock(F, 2);
    print F $str;
    close(F);
}

### ѥեؤν񤭹
sub write_to_spamlogfile {
#    my $str = "remote_host: ". $q->remote_host(). "\n";
#    $str .= "id: $logid\n";
#    $str .= "mail or url: $mail_or_url\n";
#    $str .= "spamurl: $spamurl\n";
#    $str .= "spamemail: $spamemail\n";
#    $str .= "spame-mail: $spame_mail\n";
#    $str .= "spamcomment: $spamcomment\n";
#    $str .= "spamtext: $spamtext\n";
#    $str .= "form displayed time: $disptime\n";
#    $str .= "comment received time: $time\n";
#    my $id = $latest_id + 1;
#    $str .= << "ADD";		# ɲ
#n[$id] = "$name";
#m[$id] = "$body";
#d[$id] = "$what_time_is_it_now";
#
#ADD
#    ;
#    open(F, ">> $spam_log_file") or die "can't open $spam_log_file : $!\n";
#    flock(F, 2);
#    print F $str;
#    close(F);
    print << '_END';
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<HTML><HEAD>
<TITLE>404 Not Found</TITLE>
</HEAD><BODY>
<H1>Not Found</H1>
The requested URL /kuttukibbs.cgi was not found on this server.<P>
<HR>
</BODY></HTML>
_END
    exit(1);
}

### ǶƤ줿Ȥɽ
sub output_latest {
    my @fl = <$log_dir/*.log>;
    my @lalist;
    foreach my $f (@fl) {
	open(F, $f) or die "$! $f";
	next if (-s $f == 0);
	my $all = join('', <F>);
	my %hash;

	my ($id) = ($f =~ /([^\/]+)\.log$/);
	set_comment_hash(\%hash, \$all);
	foreach my $i (keys %hash) {
	    push @lalist, {d => $hash{$i}{'d'}, m => $hash{$i}{'m'},
			   n => $hash{$i}{'n'}, i => $id};
	}
	@lalist = (sort {$b->{d} cmp $a->{d}}
		   @lalist)[0..($latest_comment_display_num - 1)];
    }
    foreach my $i (@lalist) {
	last if $i eq "";
	$comments .= make_comment_html($i, 0);
    }

    $cgi_url .= "?mode=latest";

    eval qq(\$page_html = << "FFF"\n$page_template_latest\nFFF\n);
    print $page_html;
    exit;
}
